# Numbers Callbacks

You can set up callback URLs to receive event notifications when your numbers are updated.
When delivering events the order is not guaranteed (for example, a failed event scheduled for retry will not block other events that were queued).
The client's callback handler must implement the state machine that can decide what to do with *unexpected* events, for example, "old" events or invalid state transitions. In these cases the handler could use the API to GET the latest state for the resource.
The callback handler is expected to "ingest" the event and respond with 200 OK. The domain-specific business logic and processes should be executed outside of the callback request, as internal asynchronous jobs.
Callbacks for all eventTypes - except NUMBER_ORDER_PROCESSING - will use 2 values for the status field: SUCCEEDED or FAILED. For NUMBER_ORDER_PROCESSING eventsTypes, the status field will reflect the Number Order state transition that happened, ex: IN_REVIEW, BLOCKED, COMPLETED, REJECTED, EXPIRED.
To use callbacks, add the following IP addresses to your allowlist:
- 54.76.19.159
- 54.78.194.39
- 54.155.83.128

 - [Secure Webhook Endpoints with HMAC](https://developers.sinch.com/docs/numbers/api-reference/numbers/numbers-callbacks/secure-webhook-endpoints-with-hmac.md): ### Secure Webhook Endpoints with HMAC Implementing HMAC (Hash-based Message Authentication Code) on your webhook endpoints will ensure the integrity of data, preventing tampering during transmission.
 - [HMAC verification](https://developers.sinch.com/docs/numbers/api-reference/numbers/numbers-callbacks/hmac-verification.md): ### HMAC verification We recommend to verify the HMAC code received with every event in your event handler. When receiving a new event on your endpoint URL, compute the HMAC of the payload using the s
 - [GET /v1/projects/{projectId}/callbackConfiguration](https://developers.sinch.com/docs/numbers/api-reference/numbers/numbers-callbacks/getcallbackconfiguration.md): Returns the callbacks configuration for the specified project
 - [PATCH /v1/projects/{projectId}/callbackConfiguration](https://developers.sinch.com/docs/numbers/api-reference/numbers/numbers-callbacks/updatecallbackconfiguration.md): Updates the callbacks configuration for the specified project
 - [POST EventsCallback](https://developers.sinch.com/docs/numbers/api-reference/numbers/numbers-callbacks/numberservice_eventscallback.md): A notification of an event sent to your configured callback URL.
